--
-- Trigger di tipo AFTER
-- il trigger fa in modo che quando una tupla delle FORNITURE viene 
-- aggiornata variando l'attributo QUANTITA, venga allineato
-- con una corrispondente variazione l'attributo QTA_TOTALE della SPEDIZIONE
-- alla quale quella FORNITURA contribuisce; nello schema una FORNITURA
-- contribuisce a una SPEDIZIONE se compare nella table SPED_DETTAGLI per quella
-- SPEDIZIONE 
--
drop trigger if exists checkforniture;
delimiter $$
create trigger checkforniture after UPDATE on forniture
for each row
begin
   if exists (select * from  FORNITURE JOIN SPED_DETTAGLI SD on New.FCOD=SD.FCOD and NEW.PCOD=SD.PCOD and NEW.PRCOD=SD.PRCOD) THEN 
   
   update SPEDIZIONI
	set QTA_TOTALE= QTA_TOTALE + NEW.QUANTITA-OLD.QUANTITA
    where SPEDIZIONI.SPCOD IN
		(select SD.SPCOD from FORNITURE JOIN SPED_DETTAGLI SD on (New.FCOD=SD.FCOD and NEW.PCOD=SD.PCOD and NEW.PRCOD=SD.PRCOD));
	END IF;
end; $$
delimiter ;
--
-- qui di seguito un breve script per il debug del trigger
UPDATE SPEDIZIONI SET QTA_TOTALE=0;
select * from forniture where FCOD = "F003";
select SP.SPCOD,SP.QTA_TOTALE from SPEDIZIONI SP natural join SPED_DETTAGLI SD natural join forniture where FORNITURE.FCOD="F003";
update forniture 
 set  quantita = quantita + 1
 where FCOD="F003";
select SP.SPCOD,SP.QTA_TOTALE from SPEDIZIONI SP natural join SPED_DETTAGLI SD natural join forniture where FORNITURE.FCOD="F003";
 
