--
-- Trigger e integrità referenziale:
--   i trigger in SQL vengono attivati PRIMA delle verifiche relative
--   ai vincoli di integrità referenziale.
--   L''esempio che segue utilizza il trigger SOLO come esempio
--   per ANTICIPARE con um messaggio un eventuale violazione, 
--   che verrebbe comunque prodotto dal sistema.
--   Il messaggio viene meorizzato in una variabile di sistema
--   denominata @MESSAGGIO, che poi si può visualizzare 
--   con un comando SELECT @MESSAGGIO
--
drop trigger if exists  verifica_dettagli;
delimiter $$
create trigger verifica_dettagli BEFORE INSERT on SPED_DETTAGLI
for each row
begin
	
    
    if not exists (select * from spedizioni where SPCOD=new.SPCOD)
			then
				set @MESSAGGIO="Integrità referenziale violata";
	END IF;
end $$
delimiter ;
insert into sped_dettagli values("SP99","F999","P999","PR99");
select @MESSAGGIO;